--------------------------------------------------------------------------------
--   _                 _                              __ _       
--  | |_   _ _ __   __| |_   _        ___ ___  _ __  / _(_) __ _ 
--  | | | | | '_ \ / _` | | | |      / __/ _ \| '_ \| |_| |/ _` |
--  | | |_| | | | | (_| | |_| |  _  | (_| (_) | | | |  _| | (_| |
--  |_|\__,_|_| |_|\__,_|\__,_| (_)  \___\___/|_| |_|_| |_|\__, |
--                                                         |___/ 
--
--  Config file processing; tries to process './config.lua'
--
--  Copyright (C) 2010, Marc Simpson
--  Licensed under GPLv3 (see LICENSE).
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
--  A lundu config file is a simple Lua table; be sure that your config.lua
--  returns this table, e.g.
--
--      return {
--        port = 3001
--      }
--------------------------------------------------------------------------------

lundu         = lundu or {}
lundu.config  = lundu.config or {}

--------------------------------------------------------------------------------

lundu.read_config = function()
  local h = io.open("config.lua")
  if ( not h ) then return end
  h:close()
  print("[Reading local config.lua]")
  --
  local f, e    = loadfile("config.lua")
  local config  = {}
  --
  if ( f ) then
    config = f() 
  else
    print("Configuration error:", e)
    return
  end
  for k,v in pairs(config) do lundu.config[k] = v end
end

lundu.print_config = function()
  lundu.utils.hr(60)
  print("~ Config ~\n")
  table.print(lundu.config)
  lundu.utils.hr(60)
end

--------------------------------------------------------------------------------
