--------------------------------------------------------------------------------
--   _                 _                             _            
--  | |_   _ _ __   __| |_   _       _ __ ___  _   _| |_ ___  ___ 
--  | | | | | '_ \ / _` | | | |     | '__/ _ \| | | | __/ _ \/ __|
--  | | |_| | | | | (_| | |_| |  _  | | | (_) | |_| | ||  __/\__ \
--  |_|\__,_|_| |_|\__,_|\__,_| (_) |_|  \___/ \__,_|\__\___||___/
--
--  Core of sinatra-like behaviour for Lua (early prototype)
--
--  Copyright (C) 2010, Marc Simpson
--  Licensed under GPLv3 (see LICENSE).
--------------------------------------------------------------------------------

lundu         = lundu or {}
lundu.config  = lundu.config or {}
lundu.routes  = {}

--------------------------------------------------------------------------------

lundu.router  = function(name)
  lundu.routes[name]  = lundu.routes[name] or {}
  return function(route, handler) lundu.routes[name][route] = handler end
end

local routers = function(a) for i,r in ipairs(a) do lundu.router(r) end end
routers({ "get", "post", "put" })

--------------------------------------------------------------------------------

lundu.config.static_dir = "public"

lundu.perform = function(http_method, path, ...)
  local handler = lundu.routes[http_method][path] 
  if ( handler ) then
    return handler(...)
  else
    local static_path     = lundu.config.static_dir .. path
    local handle, errstr  = io.open(static_path)
    if ( handle ) then
      local content = handle:read("*a")
      handle:close()
      return content
    end
    return { error = 404 }
  end
end

--------------------------------------------------------------------------------
