--------------------------------------------------------------------------------
--   _                 _             _                       _       _       
--  | |_   _ _ __   __| |_   _      | |_ ___ _ __ ___  _ __ | | __ _| |_ ___ 
--  | | | | | '_ \ / _` | | | |     | __/ _ \ '_ ` _ \| '_ \| |/ _` | __/ _ \
--  | | |_| | | | | (_| | |_| |  _  | ||  __/ | | | | | |_) | | (_| | ||  __/
--  |_|\__,_|_| |_|\__,_|\__,_| (_)  \__\___|_| |_| |_| .__/|_|\__,_|\__\___|
--                                                    |_| 
--
--  A (stupidly) simple HTML template implementation.
--
--  Copyright (C) 2010, Marc Simpson
--  Licensed under GPLv3 (see LICENSE).
--------------------------------------------------------------------------------

lundu         = lundu or {}
lundu.config  = lundu.config or {}

--------------------------------------------------------------------------------

lundu.config.template_dir  = "views"
lundu.config.layout_dir    = "layouts"
lundu.config.layout        = nil

--------------------------------------------------------------------------------

local template_ = function(name, t)
  -- TODO Generalise path separator (currently hard-coded for Unix-like systems)
  local handle  = io.open(lundu.config.template_dir .. "/" .. name) 
  if ( not handle ) then 
    print("error> couldn't find template: " .. name)
    return { error = 404 }
  end
  local content = handle:read("*a")
  local output  = string.gsub(content, "<%% *([^%% ]*) *%%>", t or {})
  handle:close()
  return output
end

lundu.template = function(name, t)
  if ( lundu.config.layout ) then
    local content = template_(name, t)
    t.content     = content
    return template_(lundu.config.layout_dir .. "/" .. lundu.config.layout, t)
  else
    return template_(name, t)
  end
end

--------------------------------------------------------------------------------
