--------------------------------------------------------------------------------
--   _                 _                   _   _ _     
--  | |_   _ _ __   __| |_   _       _   _| |_(_) |___ 
--  | | | | | '_ \ / _` | | | |     | | | | __| | / __|
--  | | |_| | | | | (_| | |_| |  _  | |_| | |_| | \__ \
--  |_|\__,_|_| |_|\__,_|\__,_| (_)  \__,_|\__|_|_|___/
--                                                     
--  Miscellaneous utilities.
--
--  Copyright (C) 2010, Marc Simpson
--  Licensed under GPLv3 (see LICENSE).
--------------------------------------------------------------------------------

lundu.utils       = lundu.utils or {}

lundu.utils.hr    = function(n) for i=1,n do io.write("-") end; print(); end 
local tab         = function(i) for j=1,i do io.write("  ") end end

local table_print = function(t, indent)
  indent = indent or 0
  for k,v in pairs(t) do
    tab(indent)
    if ( type(v) == "table" ) then
      io.write(k .. " = {\n")
      table.print_(v, indent+1)
      tab(indent)
      print("}")
    else
      local s = tostring(v)
      if ( type(v) == "string" ) then s = '"' .. v .. '"' end
      io.write(string.format("%-16s = %s,\n", k, s))
    end
  end
end

table.print = function(t) print("{") table_print(t, 1) print("}") end

--------------------------------------------------------------------------------
